registerOutputEvent(fxDtsbrick,"detectDirection","list Up 0 Down 1 North 2 East 3 South 4 West 5","int 1 1000 1",1);

function fxDtsBrick::detectDirection(%brick,%dir, %dist,%client)
{
	%dist = 1;
	if(%brick.isDead() || %brick.isFakeDead() || !%brick.isRaycasting() || %dist ==0)
		return;
	
	%start = %brick.getPosition();
	
	if(%dir > 1)
		%dist *= 0.5;
	%x = 0;
	%y = 0;
	%z = 0;
	%brickStr ="";
	
	echo("dir"SPC%dir);
	
	switch(%dir)
	{
		case 0: //UP
			%end = 0 SPC 0 SPC %dist;
			%dist *= 0.6;
			%x = getWord(%brick.getObjectBox(),0)+0.01;
			%y = getWord(%brick.getObjectBox(),1)+0.01;
			%z = -%dist;
		case 1:
			%end = 0 SPC 0 SPC  -%dist;
			%dist *= 0.6;
			%x = getWord(%brick.getObjectBox(),0)+0.01;
			%y = getWord(%brick.getObjectBox(),1)+0.001;
			%z = -%dist;
		case 2:
			%end = 0 SPC %dist SPC 0;
			%x = getWord(%brick.getObjectBox(),0)+0.01;
			%z = getWord(%brick.getObjectBox(),2)+0.01;
			%y = -%dist;
		case 3:
			%end = %dist SPC 0 SPC 0;
			%y = getWord(%brick.getObjectBox(),1)+0.01;
			%z = getWord(%brick.getObjectBox(),2)+0.01;
			%x = -%dist;
		case 4:
			%end = 0 SPC -%dist SPC 0;
			%x = getWord(%brick.getObjectBox(),0)+0.01;
			%z = getWord(%brick.getObjectBox(),2)+0.01;
			%y = -%dist;
		case 5:
			%end =  -%dist SPC 0 SPC 0;
			%y = getWord(%brick.getObjectBox(),1)+0.01;
			%z = getWord(%brick.getObjectBox(),2)+0.01;
			%x = -%dist;
	}
	
	%offset = -%x -0.1 SPC -%y -0.1 SPC -%z -0.1;
	%vec = (mAbs(%x/%dist) == 1) SPC (mAbs(%y/%dist) == 1) SPC (mAbs(%z/%dist) == 1);

	
	
	//initContainerBoxSearch(VectorAdd(%start, VectorScale(%end,0.5)), VectorAdd(%offset,VectorScale(%end,0.5)),$Typemasks::FxBrickObjectType);

	echo(firstWord(%offset) SPC getWord(%offset,1) SPC	 getWord(%offset,2));
	%ray = containerFindFirst($Typemasks::FxBrickObjectType ,VectorAdd(%start, VectorScale(%end,0.5)),firstWord(%offset), getWord(%offset,1), getWord(%offset,2));
	if(%ray == %brick)
	{
		%ray = containerFindNext();
	}
	
	%detected = false;
	if(%ray !$= "")
	{
		
		if(isObject(%ray))
		{
			%brick.onDetect(%brick,%client);
			%ray.onDetected(%ray,%client);
			%detected = true;
		}
	}
	
	while(isObject(%ray = containerFindNext()))
	{
		if(isObject(%ray))
		{
			%ray.onDetected(%ray,%client);
		}
	}
	if(%detected == false;)
	%brick.onNotDetect(%brick, %client);
}


registerInputEvent("fxDTSBrick", "onNotDetect",  "Self fxDTSBrick" TAB
                                                 "Player Player" TAB
                                                 "Client GameConnection" TAB
                                                 "MiniGame MiniGame");

function fxDTSBrick::onNotDetect(%obj,%client)
{
	
   $InputTarget_["Self"]   = %obj;
   $InputTarget_["Player"] = %client.player;
   $InputTarget_["Client"] = %client;

   if($Server::LAN)
   {
      $InputTarget_["MiniGame"] = getMiniGameFromObject(%client);
   }
   else
   {
      if(getMiniGameFromObject(%obj) == getMiniGameFromObject(%client))
         $InputTarget_["MiniGame"] = getMiniGameFromObject(%obj);
      else
         $InputTarget_["MiniGame"] = 0;
   }

	%obj.processInputEvent("onNotDetect", %client);
}

registerInputEvent("fxDTSBrick", "onDetect",  "Self fxDTSBrick" TAB
                                                 "Player Player" TAB
                                                 "Client GameConnection" TAB
                                                 "MiniGame MiniGame");

function fxDTSBrick::onDetect(%obj,%client)
{
		
   $InputTarget_["Self"]   = %obj;
   $InputTarget_["Player"] = %client.player;
   $InputTarget_["Client"] = %client;

   if($Server::LAN)
   {
      $InputTarget_["MiniGame"] = getMiniGameFromObject(%client);
   }
   else
   {
      if(getMiniGameFromObject(%obj) == getMiniGameFromObject(%client))
         $InputTarget_["MiniGame"] = getMiniGameFromObject(%obj);
      else
         $InputTarget_["MiniGame"] = 0;
   }
   
	%obj.processInputEvent("onDetect", %client);
}

registerInputEvent("fxDTSBrick", "onDetected",  "Self fxDTSBrick");

function fxDTSBrick::onDetected(%obj,%client)
{
	$InputTarget_["Self"]   = %obj;
	%obj.processInputEvent("onDetected", %client);
}